#!/usr/bin/python
'''
Created on Nov 12, 2010

@author: dfarris
'''
from Location import Location
from random import *
from sys import argv,exit
from pylab import *
from threading import Thread

def Normalize(list,total,verbose):
    '''
    Normalize the weights such that they total 1
    '''   

    running_total = 0
    for location in list:
        if location.weight < .000001:
           location.is_deleted = True
        else:
            location.weight = location.weight/total
            s = "weight for " + str(location.position) + ": " + str(location.weight)
            if verbose:
                print s
            running_total += location.weight
    
    if verbose:
        print " "
        print "Sum: " + str(running_total)
        print " "
    
def MaximumWeight(locations,verbose):
    '''
    Finds the Maximum weight of the given locations
    '''    
    spot = 0    
    weight = locations[0].weight    
    for location in locations:
        weight2 = location.weight
        if weight2 > weight:
           weight = weight2
           spot = location.position
    return weight,spot

def SimulationTrain(count, train, largest_spot, holes, locations):

    i = 0
    while count < train:

        #if self.largest_spot == holes[i]:
        #break
        if holes[i] != 42:
            locations[holes[i]].weight *= 1.1
            total=0
            for location in locations:
                if location.is_deleted != True:
                    total += location.weight
            Normalize(locations,total,verbose)
            largest_weight, largest_spot = MaximumWeight(locations,verbose)
        if i==8:
            i = 0
        else:
            i += 1

        count += 1
    return largest_spot, locations, i

class Threads(Thread):
    
    def __init__(self,iterations,verbose,train):
        Thread.__init__(self)
        self.num_spaces = 27.0
        self.locations = []
        self.original = []
        self.iterations = iterations
        self.train = train
        self.verbose = verbose
        self.largest_spot = 0
        self.count = 1

    def run(self):

        holes = [3,20,6,18,42,9,12,24,15,22]
        i = 0
        '''
        if len(argv)==2:
            if argv[1] == '-v':
                verbose = True
            else:
                print "Usage: -v for verbosity\n"
                exit()
        else:
            verbose = False        
        '''
        #Create list of Location Objects
        total = 0
        while (i <= self.num_spaces-1):    
            rand_weight = randrange(0,100,1)/100.0
            while rand_weight == 0.0:
                rand_weight = randrange(0,100,1)/100.0      
            spot = Location(rand_weight,i,0,False,False)
            self.locations.append(spot)
            total += rand_weight
            i += 1

        running_total = 0
   
        #Normalize the weights of the locations
        Normalize(self.locations,total,verbose)
        weight, spot = MaximumWeight(self.locations,verbose)
        if spot==holes[0]:
            if self.verbose:
               print "You Win!"
               return

        #This is the main simulation loop
        i=0
        self.largest_spot = spot
        self.count = 1

        if (self.train != 0):
            self.largest_spot, self.locations, i = SimulationTrain(self.count,self.train,
			                                                    self.largest_spot,holes, self.locations)
        
        self.count = 1		
        while self.count < self.iterations:

            if self.largest_spot == holes[i]:
                if self.verbose:
                    print "Victory!"
                    print self.count
                break
            if holes[i] != 42:
                self.locations[holes[i]].weight *= 1.1
                if self.verbose:
                    print "Hole Location: " + str(holes[i])
                    print "NEW WEIGHT " + str(self.locations[holes[i]].weight) + "\n"

                total=0
                for location in self.locations:
                    if location.is_deleted != True:
                        total += location.weight
        
                Normalize(self.locations,total,self.verbose)
                largest_weight, self.largest_spot = MaximumWeight(self.locations,self.verbose)
            if i==8:
                i = 0
            else:
                i += 1
            if self.verbose:
                print "Iteration: " + str(self.count)
                print "Max weight: " + str(largest_weight) + " Max Spot: " + str(self.largest_spot)
                print "____________________________________"

            self.count += 1

if __name__ == '__main__':
    
    threads = 0
    iterations = 0
    train = -1
    verbose_flag = 0

    while not(threads):
        try:
            threads = int(raw_input("Number of threads: "))
        except ValueError:
            print "Thread value must be integer"
    while not(iterations):
        try:
            iterations = int(raw_input("Number of max iterations per thread: "))
        except ValueError:
            print "iterations must be an integer"
    while (train < 0):
        try:
            train = int(raw_input("Number of Training runs (0 for no training): "))
        except ValueError:
            print "Training runs must be an integer"

    if threads == 1: 
        verbose = True
    else:
        verbose = False

    win_states = []
    num_iter = []
    for i in range(threads):
        current = Threads(iterations,verbose,train)
        current.start()
        current.join()
        win_states.append(current.largest_spot)
        num_iter.append(current.count)

    num_failed = 0
    num_success = 0
    for i in range(len(num_iter)):
        if num_iter[i] == iterations:
            #print "Simulation failed on hole: " + str(win_states[i]) + " iter: " + str(num_iter[i])
            num_failed += 1
        else:
            #print "Winning hole: " + str(win_states[i]) + " iter: " + str(num_iter[i])
            num_success += 1
    
    num_iter.sort()
    min_iter = num_iter[0]
    max_iter = num_iter[threads-1]
    avg_iter = sum(num_iter)*1.0/len(num_iter)*1.0
    win_states.sort()
    min_state = win_states[0]
    max_state = win_states[threads-1]
    avg_state = sum(win_states)*1.0/len(win_states)*1.0

    print " " 
    print "Statistics"
    print "_______________________________"
    print "Number of Successes: " + str(num_success)
    print "Number of Failures: " + str(num_failed) + "\n"
    print "Min iterations: " + str(min_iter)
    print "Max iterations: " + str(max_iter)
    print "Average iterations " + str(avg_iter) + "\n"
    print "Min winning position: " + str(min_state)
    print "Max winning position: " + str(max_state)
    print "Average winning position: " + str(avg_state) + "\n"
